/*
 * Boggle - TOP PROJET ESIAL 2011
 * Copyright (C) 2011 Julien VAUBOURG / Igor MARTY
 * Contact <julien@vaubourg.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package boggle;

import java.io.Serializable;
import java.util.Random;

public class Dice implements Serializable {
	private static final long serialVersionUID = -3670163140885305850L;
	private char[] values;
	private int idValue = 0;

	/**
	 * Cree un de a partir de la definition de ses faces. 
	 * @param values Tableau des 6 faces du de
	 */
	public Dice(char[] values) {
		this.values = values;
	}

	/**
	 * Retourne la face visible du de.
	 * @return Face visible du de
	 */
	public char getValue() {
		return values[idValue];
	}

	/**
	 * Lance le de pour definir sa valeur aleatoirement.
	 */
	public void roll() {
		idValue = new Random().nextInt(values.length);
	}	

	/**
	 * Affiche la valeur du de 
	 */
	public String toString() {
		return String.valueOf(getValue());
	}
}