/*
 * Boggle - TOP PROJET ESIAL 2011
 * Copyright (C) 2011 Julien VAUBOURG / Igor MARTY
 * Contact <julien@vaubourg.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package boggle;

import java.io.IOException;

public class PlayerClientLocal extends PlayerClient {
	public final static String DEFAULT_HOST = "localhost";

	/**
	 * Cree le joueur local de la machine cliente.
	 * @param name Nom du joueur
	 * @param game Controleur du jeu
	 */
	public PlayerClientLocal(String name, Game game) {
		super(name, game, DEFAULT_HOST);
	}

	/**
	 * Delegue la verification du mot au serveur, et transmet eventuellement l'exception
	 * qui va avec.
	 */
	@Override
	public void checkWord(String word) throws WordException, IOException {
		game.getClientSocket().sendWord(word, this);
	}

	/**
	 * Fait jouer le joueur, et force a terminer par un mot vide.
	 */
	@Override
	public void play() throws IOException, InterruptedException {
		super.play();

		try { checkWord(""); }
		catch (WordException e) {}
	}
}