package tests;

import boggle.Board;
import boggle.Dice;
import junit.framework.TestCase;

public class BoardTest extends TestCase {

	/**
	 * Test du melange des des du plateau
	 */
	public void testRoll() {
		char[][] dSides_sameByCol = {
				{ 'A', 'A', 'A', 'A', 'A', 'A' },
				{ 'B', 'B', 'B', 'B', 'B', 'B' },
				{ 'C', 'C', 'C', 'C', 'C', 'C' },
				{ 'D', 'D', 'D', 'D', 'D', 'D' }
		};

		char[][] dSides_sameByRow = {
				{ 'A', 'B', 'C', 'D', 'E', 'F' },
				{ 'A', 'B', 'C', 'D', 'E', 'F' },
				{ 'A', 'B', 'C', 'D', 'E', 'F' },
				{ 'A', 'B', 'C', 'D', 'E', 'F' },
		};

		Dice[][] d_testTurnOver = {
				{ new Dice(dSides_sameByCol[0]), new Dice(dSides_sameByCol[1]) },
				{ new Dice(dSides_sameByCol[2]), new Dice(dSides_sameByCol[3]) }
		};

		Dice[][] d_testDicesRoll = {
				{ new Dice(dSides_sameByRow[0]), new Dice(dSides_sameByRow[1]) },
				{ new Dice(dSides_sameByRow[2]), new Dice(dSides_sameByRow[3]) }
		};

		Board b = new Board();
		b.setField(d_testTurnOver);
		String field = b.toString();

		for(int i = 0; i < 10 && b.toString().equals(field); b.roll(), i++);
		
		// Teste si les des changent bien aleatoirement de place
		assertTrue(b.toString() != field);
		
		b = new Board();
		b.setField(d_testDicesRoll);
		field = b.toString();
		
		for(int i = 0; i < 10 && b.toString().equals(field); b.roll(), i++);

		// Teste si les des changent bien de valeur en etant lances
		assertTrue(b.toString() != field);
	}
}