package tests;

import boggle.Dice;
import junit.framework.TestCase;

public class DiceTest extends TestCase {
	private char[] dSides_allSame = {'A', 'A', 'A', 'A', 'A', 'A'};
	private char[] dSides_allDiff = {'A', 'B', 'C', 'D', 'E', 'F'};

	/**
	 * Teste le retour de la valeur du de
	 */
	public void testGetValue() {
		Dice d = new Dice(dSides_allSame);

		assertEquals(d.getValue(), dSides_allSame[0]);
	}

	/**
	 * Teste si le de tourne bien
	 */
	public void testRoll() {
		Dice d = new Dice(dSides_allDiff);
		char side = d.getValue();

		for(int i = 0; i < 20 && d.getValue() == side; d.roll(), i++);

		assertTrue(d.getValue() != side);
	}

	/**
	 * Teste l'affichage du de
	 */
	public void testToString() {
		Dice d = new Dice(dSides_allSame);
		
		assertEquals(d.toString(), String.valueOf(dSides_allSame[0]));
	}
}