package tests;

import java.util.ArrayList;

import boggle.Game;
import boggle.IOGameText;

public class IOGameTest extends IOGameText {
	private static final long serialVersionUID = -1154033356016856828L;
	private ArrayList<String> stdin;
	private ArrayList<String> stdout;

	/**
	 * Cree une vue dediee aux tests, qui permet de definir le stdin.
	 * @param stdin
	 */
	public IOGameTest(String[] stdin) {
		super(new Game());

		this.stdin = new ArrayList<String>();
		this.stdout = new ArrayList<String>();

		for(String line : stdin)
			this.stdin.add(line);
	}
	
	/**
	 * Retourne la prochaine ligne du faux stdin. 
	 * @return La prochaine ligne du faux stdin
	 */
	private String currentLine() {
		String value;
		
		if(stdin.size() > 0) {
			value = stdin.get(0);
			stdin.remove(0);
		} else
			value = "";

		return value;
	}

	@Override
	public String inPlayerName() {
		return currentLine();
	}

	@Override
	public String inWord() {
		return currentLine();
	}

	@Override
	public void outErrorPlayerName() {}

	@Override
	public void outErrorWord(String msg) {
		stdout.add(msg);
	}
	
	public String print() {
		return stdout.toString();
	}
	
	public String printLast() {
		return stdout.get(stdout.size() - 1);
	}

	public void addLine(String value) {
		stdin.add(value);
	}
}