package tests;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import boggle.LexiconTrie;

import junit.framework.TestCase;

public class LexiconTest extends TestCase {

	/**
	 * Teste de la lecture du fichier de dictionnaire.
	 */
	public void testRead() {
		String fileName = "ODS5.txt.gz";
		LexiconTrie l = new LexiconTrie();
		int nbDef = -1;

		try {
			Process p = Runtime.getRuntime().exec("zgrep -cv '^;' " + fileName);
			BufferedReader stdin = new BufferedReader(new InputStreamReader(p.getInputStream()));
			nbDef = Integer.valueOf(stdin.readLine());

		} catch (IOException t) {
			System.err.println("OMG, I'm afraid you're on Windows :/");
		}

		try {
			l.read(fileName);

			// Teste du nombre de mots pris en compte
			assertEquals(l.size(), nbDef);

		} catch (IOException e) {
			System.err.print("Definitions file not found for test !");
		}
	}

	/**
	 * Teste de l'ajout de mot.
	 */
	public void testAdd() {
		LexiconTrie l = new LexiconTrie();

		l.add("douglas");

		assertTrue(l.contains("douglas"));
	}

	/**
	 * Teste de la suppression de mot.
	 */
	public void testRemove() {
		LexiconTrie l = new LexiconTrie();

		l.add("douglas");
		l.remove("douglas");

		assertFalse(l.contains("douglas"));
	}

	/**
	 * Teste de la recherche de mot.
	 */
	public void testContains() {
		LexiconTrie l = new LexiconTrie();

		l.add("douglas");

		assertTrue(l.contains("douglas"));
	}

	/** 
	 * Teste de la taille du dictionnaire.
	 */
	public void testSize() {
		LexiconTrie l = new LexiconTrie();

		l.add("adam");
		l.add("douglas");
		l.add("intergalactic");

		assertEquals(l.size(), 3);
	}
}